/******************************************************************************
 * Copyright (c) 2000-2025 Ericsson Telecom AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/org/documents/epl-2.0/EPL-2.0.html
 ******************************************************************************/
package org.eclipse.titan.common.utils;

import java.net.InetAddress;
import java.text.MessageFormat;

/**
 * Util class for providing comments for different kinds of generated files,
 * e.g. Java source files, bash files, XML files etc.
 * @author Adam Knapp
 * */
public final class CommentUtils {
	private static final String HEADER_COMMENT_TEXT = 
			  "{0}This file was generated by the TITAN Designer Eclipse plug-in version {1}\n"
			+ "{0}for ({2}@{3})";
	public static final String COPYRIGHT_TEXT = "Copyright (c) 2000-2025 Ericsson Telecom AB";
	public static final String DO_NOT_EDIT_TEXT = "Do not edit this file unless you know what you are doing!";
	public static final String ECLIPSE_LICENSE_TEXT = 
			  "{0}All rights reserved. This program and the accompanying materials\n"
			+ "{0}are made available under the terms of the Eclipse Public License v2.0\n"
			+ "{0}which accompanies this distribution, and is available at\n"
			+ "{0}https://www.eclipse.org/org/documents/epl-2.0/EPL-2.0.html\n";

	/**
	 * Returns the header comment using the specified comment char
	 * @param commentChar Character indicating the start of comment
	 * @param versionString Version of Titan
	 * @return The header comment 
	 */
	public static String getHeaderComments(final char commentChar, final String versionString) {
		return getHeaderComments(String.valueOf(commentChar) + " ", versionString);
	}

	/**
	 * Returns the header comment using the specified comment string
	 * @param commentString String indicating the start of comment
	 * @param versionString Version of Titan
	 * @return The header comment 
	 */
	public static String getHeaderComments(final String commentString, final String versionString) {
		String userName;
		String hostName;
		try {
			userName = System.getProperty("user.name");			
		} catch (Exception e) {
			userName = "unknown";
		}
		try {
			hostName = InetAddress.getLocalHost().getHostName();
		} catch (Exception e) {
			hostName = "unknown";
		}
		return MessageFormat.format(HEADER_COMMENT_TEXT, commentString,
				versionString, userName, hostName);
	}

	/**
	 * Returns the header comment using the specified comment string. It is extended with the copyright text.
	 * @param commentString String indicating the start of comment
	 * @param versionString Version of Titan
	 * @return The header comment 
	 */
	public static String getHeaderCommentsWithCopyright(final String commentString, final String versionString) {
		return getHeaderComments(commentString, versionString) + "\n" + commentString + COPYRIGHT_TEXT + "\n\n";
	}

	/**
	 * Returns the header comment using the specified comment string.
	 * It is extended with the copyright and do not edit texts.
	 * @param commentString String indicating the start of comment
	 * @param versionString Version of Titan
	 * @return The header comment 
	 */
	public static String getHeaderCommentsWithCopyrightAndDoNotEdit(final String commentString, final String versionString) {
		return getHeaderCommentsWithCopyright(commentString, versionString) + "\n" + commentString + DO_NOT_EDIT_TEXT + "\n";
	}

	/**
	 * Returns the header comment with the license text using the specified comment string.
	 * @param commentString String indicating the start of comment
	 * @param versionString Version of Titan
	 * @return The header comment
	 */
	public static String getHeaderCommentsWithCopyrightAndLicenseAndDoNotEdit(final String commentString, final String versionString) {
		return getHeaderCommentsWithCopyright(commentString, versionString) + getLicenseComment(commentString) + "\n" + commentString + DO_NOT_EDIT_TEXT + "\n\n";
	}

	/**
	 * Returns the license text using the specified comment string.
	 * @param commentString String indicating the start of comment
	 * @return The header comment
	 */
	public static String getLicenseComment(final String commentString) {
		return MessageFormat.format(ECLIPSE_LICENSE_TEXT, commentString);
	}
}
